<?

function dbg_sc($tag, $val)
{
	setcookie($tag, $val, time() + (3600 * 24) * 365, "/");
	$_COOKIE[$tag] = $val;
}

function dbg($msg, $force = false)
{
	global $dbg;
	if($dbg || $force)
	{
		?>
		<div style="background-color: #abf; color: #000; font-family: courier;">
		<?
		if(is_object($msg) || is_array($msg))
		{
			echo "<pre>";
			print_r($msg);
			echo "</pre>";
		}
		else
			echo $msg;
		?>
		</div>
		<?
	}
}

function fdbg($msg)
{
	dbg($msg, true);
}

function dbgf($msg)
{
	dbg($msg);
	flush();
	ob_flush();
}

function xdbg($msg)
{
	fdbg($msg);
	exit;
}

function dbgpre($msg)
{
	dbg("<pre>".$msg."</pre>");
}

function dbgh($msg)
{
	$msg = preg_replace("/</", "&lt;", $msg);
	$msg = preg_replace("/>/", "&gt;", $msg);
	dbg($msg);
}

function here()
{
	fdbg(__FILE__.":".__LINE__);
}


// Convert errors into Exceptions
function exception_error_handler($errno, $errstr, $errfile, $errline)
{
	throw new ErrorException($errstr, 0, $errno, $errfile, $errline);
}
set_error_handler("exception_error_handler", E_ALL ^ E_NOTICE);



if(isset($_COOKIE["dbg"]))
	$dbg = ($_COOKIE["dbg"] == "true") ? true : false;
if(isset($_GET["dbg"]))
{
	$pass_required = substr($_SERVER["SERVER_NAME"],0,4);
	$pass_given = $_GET["dbg"];
	if($pass_given == $pass_required)
	{
		dbg_sc("dbg", "true");
		$dbg = true;
		dbg("Debug mode enabled");
	}
	else
	if($_GET["dbg"] == "off")
	{
		dbg_sc("dbg", "false");
		$dbg = false;
	}
}

if(isset($dbg) && $dbg)
{
	ini_set('display_errors', 1);
	error_reporting(E_ALL ^ E_NOTICE);
}

?>
