<?php


function fb_rest($method, $args)
{
	global $fb_api_key, $fb_sec_key;

	$a = array(
		'method' => $method,
		'api_key' => $fb_api_key,
		'call_id' => microtime(true), 
		'v' => '1.0',
		'format' => 'JSON',
		);
	$a = array_merge($a, $args);
	ksort($a);
	$sig = '';
	foreach($a as $k=>$v)
		$sig .= "$k=$v";
	$sig = md5($sig.$fb_sec_key);
	$url = "http://api.facebook.com/restserver.php?sig=".$sig;
	foreach($a as $k => $v)
		$url .= "&".$k."=".(urlencode($v));
	# dbg("url=$url");
	$json = file_get_contents($url);
	# dbg("json=|".($json)."|");
	# return json2obj($json);
	return $json;
}

function fb_user_getInfo($user)
{
	global $user, $session_key;

	$json = fb_rest("users.getInfo", array(
		'session_key'=>$session_key,
		'uids'=>$user,
		'fields'=>"birthday,name,is_app_user,pic,profile_url,status",
		));
	// xxx return just first array element if no commas in $user?
	return $json;
}


function fb_notifications_send($msg, $to_ids)
{
	global $user, $session_key;

	$json = fb_rest("notifications.send", array(
		'session_key'=>$session_key,
		'to_ids'=>$to_ids,
		'notification'=>$msg,
		'type'=>"user_to_user",
		));
	// xxx return just first array element if no commas in $user?
	return $json;
}


?>
