/* Copyright 3000 Sleepless Software Inc.  All Rights Reserved */

/*
	Fat Client JS support.
*/

document.write("<form id='fcform'></form>\n");


function fcTrim(s)
{
	s = s.replace( /^\s+/gi, "" );      // nuke leading whitespace
	s = s.replace( /\s+$/gi, "" );      // nuke trailing whitespace
	return s;
}

function fcElem(id)
{
	return document.getElementById(id);
}

function fcSplit(l)
{
	l = fcTrim(l);
	var a = l.split("|");
	for(var i = 0; i < a.length; i++)
	{
		var p = a[i].split("=", 2);
		p[0] = fcTrim(p[0]);
		if(p.length > 1)
			p[1] = fcTrim(p[1]);
		else
			p[1] = fcTrim(fcElem(p[0]).value);
		a[i] = p;
	}
	return a;
}

fcForm = fcElem("fcform");

function fcAddVal(f, id, val)
{
	f.innerHTML = f.innerHTML + '<input type="hidden" id="HID'+id+'">\n';
	var hid = f.elements.namedItem("HID"+id);
	hid.name = id;
	hid.value = val;
}

function fcFormSubmit(url, list, method)
{
	var arr = fcSplit(list);
	for(var i = 0; i < arr.length; i++)
	{
		var tv = arr[i];
		fcAddVal(fcForm, tv[0], tv[1]);
	}
	fcForm.method = method;
	fcForm.action = url;
	fcForm.submit();
}

function fcFormGet(url, list) { fcFormSubmit(url, list, "get"); }
function fcFormPost(url, list) { fcFormSubmit(url, list, "post"); }

function fcAjax(url, list, cb)
{
	var c = "?";
	if(list)
	{
		var a = fcSplit(list);
		for(var i = 0; i < a.length; i++)
		{
			var tv = a[i];
			url = url + c + tv[0] + "=" + escape(tv[1]);
			c = "&";
		}
	}
	msg("ajax url="+url);
	new Ajax().get(url, cb);
}

