<?

function i_textarea($cols = 40, $rows = 2, $n = "textarea", $v = "", $c = "", $e = "")
{
	return "<textarea
			cols=\"$cols\"
			rows=\"$rows\"
			name=\"".$n."\"
			id=\"".$n."\"
			class=\"".$c."\"
			onclick='if(window.clicked)clicked(this,event)'
			onchange='if(window.changed)changed(this,event)'
			onkeydown='if(window.typed)typed(this,event)'
			$e
			/>$v</textarea>";
}

function i_input($t = "text", $n = "text", $v = "", $c = "", $e = "")
{
	return "<input
			type=\"$t\"
			name=\"".$n."\"
			value=\"".valsafe($v)."\"
			id=\"".$n."\"
			class=\"".$c."\"
			onclick='if(window.clicked)clicked(this,event)'
			onchange='if(window.changed)changed(this,event)'
			onkeydown='if(window.typed)typed(this,event)'
			$e
			/>";
}

function i_text($n = "text", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);
}

function i_ccard($n = "ccard", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, "size=16 ".$e);
}

function i_date($n = "date", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);	// xxx
}

function i_label($n = "text", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e." readonly");
}

function i_int($n = "int", $v = "", $c = "", $e = "", $sz = 5)
{
	return i_input('text', $n, $v, $c, $e." size=$sz");
}

function i_int_3($n = "int3", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e." size=3");
}

function i_float($n = "float", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);
}

function i_float_4($n = "float", $v = "", $c = "", $e = "")
{
	return i_float($n, $v, $c, $e." size=4");
}

function i_prefix($n = "prefix", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);
}

function i_first_name($n = "first_name", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);
}

function i_last_name($n = "last_name", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);
}

function i_full_name($n = "full_name", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);
}

function i_suffix($n = "suffix", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);
}

function i_addr1($n = "address1", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e." size=40");
}

function i_addr2($n = "address2", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e." size=40");
}

function i_city($n = "city", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);
}

function i_state($n = "state", $v = "", $c = "", $e = "")
{
	//return i_input('text', $n, $v, $c, $e);
	$states = array(
		"", "",
		"ALABAMA", "AL", 
		"ALASKA", "AK", 
		"AMERICAN SAMOA", "AS", 
		"ARIZONA", "AZ", 
		"ARKANSAS", "AR", 
		"CALIFORNIA", "CA", 
		"COLORADO", "CO", 
		"CONNECTICUT", "CT", 
		"DELAWARE", "DE", 
		"DISTRICT OF COLUMBIA", "DC", 
		"FEDERATED STATES OF MICRONESIA", "FM", 
		"FLORIDA", "FL", 
		"GEORGIA", "GA", 
		"GUAM", "GU", 
		"HAWAII", "HI", 
		"IDAHO", "ID", 
		"ILLINOIS", "IL", 
		"INDIANA", "IN", 
		"IOWA", "IA", 
		"KANSAS", "KS", 
		"KENTUCKY", "KY", 
		"LOUISIANA", "LA", 
		"MAINE", "ME", 
		"MARSHALL ISLANDS", "MH", 
		"MARYLAND", "MD", 
		"MASSACHUSETTS", "MA", 
		"MICHIGAN", "MI", 
		"MINNESOTA", "MN", 
		"MISSISSIPPI", "MS", 
		"MISSOURI", "MO", 
		"MONTANA", "MT", 
		"NEBRASKA", "NE", 
		"NEVADA", "NV", 
		"NEW HAMPSHIRE", "NH", 
		"NEW JERSEY", "NJ", 
		"NEW MEXICO", "NM", 
		"NEW YORK", "NY", 
		"NORTH CAROLINA", "NC", 
		"NORTH DAKOTA", "ND", 
		"NORTHERN MARIANA ISLANDS", "MP", 
		"OHIO", "OH", 
		"OKLAHOMA", "OK", 
		"OREGON", "OR", 
		"PALAU", "PW", 
		"PENNSYLVANIA", "PA", 
		"PUERTO RICO", "PR", 
		"RHODE ISLAND", "RI", 
		"SOUTH CAROLINA", "SC", 
		"SOUTH DAKOTA", "SD", 
		"TENNESSEE", "TN", 
		"TEXAS", "TX", 
		"UTAH", "UT", 
		"VERMONT", "VT", 
		"VIRGIN ISLANDS", "VI", 
		"VIRGINIA", "VA", 
		"WASHINGTON", "WA", 
		"WEST VIRGINIA", "WV", 
		"WISCONSIN", "WI", 
		"WYOMING", "WY", 
		"Armed Forces Africa", "AE", 
		"Armed Forces Americas (except Canada)", "AA",
		"Armed Forces Canada", "AE", 
		"Armed Forces Europe", "AE", 
		"Armed Forces Middle East", "AE", 
		"Armed Forces Pacific", "AP",
		);
	$s = "<select name='$n' id='$n' onchange='if(window.changed)changed(this,event)' >\n";
	for($i = 0; $i < count($states); $i += 2)
	{
		$l = $states[$i + 0];
		$a = $states[$i + 1];
		$sel = "";
		if($a == $v)
			$sel = "selected";
		$s .= "<option $sel value=\"$a\">$l</option>\n";
	}
	$s .= "</select>\n";
	return $s;
}

function i_zip_code($n = "zip_code", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e." size=16");
}

function i_phone($n = "phone", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e." size=16");
}

function i_mobile($n = "mobile", $v = "", $c = "", $e = "")
{
	return i_phone($n, $v, $c, $e);
}

function i_fax($n = "fax", $v = "", $c = "", $e = "")
{
	return i_phone($n, $v, $c, $e);
}

function i_dob($n = "dob", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);	// xxx
}

function i_email($n = "email", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e);
}

function i_password($n = "password", $v = "", $c = "", $e = "")
{
	return i_input('password', $n, $v, $c, $e);
}

function i_hidden($n = "hidden", $v = "", $c = "", $e = "")
{
	return i_input('hidden', $n, $v, $c, $e);
}

function i_submit($n = "submit", $v = "", $c = "", $e = "")
{
	if(!$v)
		$v = ucfirst($n);
	return i_input('submit', $n, $v, $c, $e);
}

function i_button($n = "", $v = "", $c = "", $e = "")
{
	if(!$v)
		$v = ucfirst($n);
	return i_input('button', $n, $v, $c, $e);
}

function i_checkbox($n = "", $v = "", $c = "", $e = "")
{
	return i_input('checkbox', $n, $v, $c, ($v!=""?"checked ":"").$e);
}

function i_checkbox_x($n = "", $v = "", $c = "", $e = "")
{
	return i_checkbox($n, 1, $c, $e);
}

function i_radio($n = "radio", $v = "", $c = "", $e = "")
{
	return i_input('radio', $n, $v, $c, $e);
}

function i_radio_x($n = "", $v = "", $c = "", $e = "")
{
	return i_radio($n, $v, $c, "checked ".$e);
}

function i_jump($l, $j, $c = "")
{
	return "<input
			type=\"button\"
			value=\"$l\"
			class=\"".$c."\"
			onclick='jmp(\"$j\")'
			$e
			/>";
}


function i_time($n = "time", $v = "", $c = "", $e = "")
{
	return i_input('text', $n, $v, $c, $e." size=5");
}

function i_continue($j, $c = "")
{
	return i_jump("Continue", $j, $c);
}

function i_select($name = "select", $items = array(), $v = "", $c="", $extra)
{
    $s = "<select name='$name'
			id=\"".$name."\"
			class=\"".$c."\"
			onclick='if(window.clicked)clicked(this,event)'
			onchange='if(window.changed)changed(this,event)'
			onkeydown='if(window.typed)typed(this,event)'
			$extra>";

    if (is_array($items))
    {
        foreach( $items as $key => $value )
        {
            $sela = ($key == $v) ? " selected='yes'" : "";
            $selb = ($value == $v) ? " selected='yes'" : "";
            //if (!is_numeric($key)) {
                $s .= "<option value='$key'$sela>$value</option>\n";
            //} else {
            //    $s .= "<option$selb>$value</option>\n";
            //}
        }
    }
    $s .= "</select>";
    return $s;
}

function i_month($name = "month", $v = "", $e = "") 
{
	return i_select($name,
		array(
			""=>"",
			"01"=>"01 Jan",
			"02"=>"02 Feb",
			"03"=>"03 Mar",
			"04"=>"04 Apr",
			"05"=>"05 May",
			"06"=>"06 Jun",
			"07"=>"07 Jul",
			"08"=>"08 Aug",
			"09"=>"09 Sep",
			"10"=>"10 Oct",
			"11"=>"11 Nov",
			"12"=>"12 Dec",
			),
		$v, "", $e);
}

function i_ccexp($mname="expmonth", $yname="expyear", $e = "")
{
	$a = range((int)date("Y"), (int)date("Y")+10);
	$a = array_combine($a,$a);
	return i_month($mname)." / ".i_select($yname, $a, "", "", $e);
}



?>
