#ifndef com_sleepless_httppost_cpp
#define com_sleepless_httppost_cpp

// Copyright 2004 Sleepless Software Inc. All Rights Reserved


#include "socket.cpp"
//#include "url.cpp"


int httpPostSimple(const char *h, int p, const char *path, char *buf, int len, char *bufout, int lenout)
{
	Socket s(h, p);
	if(!s.isConnected())
		return -1;

	s.writeStr("POST ");
	s.writeStr(path);
	s.writeStr(" HTTP/1.0\n");

	s.writeStr("Content-length: ");
	s.writeInt(lenout);
	s.writeStr("\n");

	s.writeStr("\n");

	s.write(bufout, lenout);


	char line[200];
	int r = 0;
	long contentLength = 0;
	while(true)
	{
		if(s.readLine(line, sizeof(line)) < 1)
			break;
		if(strcmp(line, "\n") == 0)
		{
			int l = len;
			if(contentLength > 0)
			{
				if(contentLength < len)
					l = contentLength;
			}
			r = s.read(buf, l);
			break;
		}

		if(strncasecmp(line, "Content-Length: ", 16) == 0)
		{
			contentLength = atol(line + 16);
		}
	}

	return r;
}

#endif	// com_sleepless_httppost_cpp
