#ifndef kencom_cpp
#define kencom_cpp

#ifdef WIN32
struct KenCom
{
	int WM_UNINSTALL_JPJWATCHER    ;//Uninstall AutoRun Registry and Exit JPJWatcher
	int WM_SUSPEND_JPJWATCHER      ;//Suspend JPJWatcher
	int WM_RESUME_JPJWATCHER       ;//Resume JPJWatcher
	int WM_KILL_JPJWATCHER         ;//Exit JPJWatcher AutoRun Registry Stays Functional
	int WM_EXE_JPJWATCHER          ;//New EXE for JPJWatcher to look at
	int WM_UNEXE_JPJWATCHER        ;//Uninstall JPJWatcher EXE By Name
	int WM_CONTROLLER_IN_JPJWATCHER;//When a Controller Gets Plugged In Tell Everybody
	int WM_EXECUTEAPP_JPJWATCHER   ;//Tell JPJWatcher to Execute an executable file.
	long appid;
	
	KenCom(const char *id)
	{
		memset(this, 0, sizeof(this));
		char *t = (char *)&appid;
		t[0] = id[3];
		t[1] = id[2];
		t[2] = id[1];
		t[3] = id[0];
		WM_UNINSTALL_JPJWATCHER     = RegisterWindowMessage("UnInstallJPJWatcher");
		WM_SUSPEND_JPJWATCHER       = RegisterWindowMessage("SuspendJPJWatcher");
		WM_RESUME_JPJWATCHER        = RegisterWindowMessage("ResumeJPJWatcher");
		WM_KILL_JPJWATCHER          = RegisterWindowMessage("KillJPJWatcher");
		WM_EXE_JPJWATCHER           = RegisterWindowMessage("EXEJPJWatcher");
		WM_UNEXE_JPJWATCHER         = RegisterWindowMessage("UNEXEJPJWatcher");
		WM_CONTROLLER_IN_JPJWATCHER = RegisterWindowMessage("ControllerInJPJWatcher");
		WM_EXECUTEAPP_JPJWATCHER    = RegisterWindowMessage("ExecuteNewAppJPJWatcher");
	}

	void appRemove()
	{
		SendMessage(HWND_BROADCAST, WM_UNEXE_JPJWATCHER, 0, appid);
	}

	void appExec()
	{
		SendMessage(HWND_BROADCAST, WM_EXECUTEAPP_JPJWATCHER, 0, appid);
	}
		
};
#endif

#endif // kencom_cpp
