<?
// Copyright 2009 Sleepless Software Inc. All Rights Reserved

class Obj {
}

function fail($msg = "ERROR")
{
	X($msg);
	exit;
}

function failif($c, $msg = "ERROR")
{
	if($c)
		fail($msg);
}

function ass($c, $m = "Failed assertion")
{
	failif(!$c, $m);
}

function p($msg)
{
	print("$msg<br>\n");
}

function p_clr($msg, $clr)
{
	p("<font color=\"$clr\">$msg</font>");
}

function p_red($msg)
{
	p_clr($msg, "red");
}
function p_green($msg)
{
	p_clr($msg, "green");
}
function blue($msg)
{
	p_clr($msg, "blue");
}


function rt($s)
{
	if(is_array($s))
	{
		foreach($s as $v)
		{
			global $$v;
			$$v = isset($_REQUEST[$v]) ? trim($_REQUEST[$v]) : "";      // xxx xxx this doesn't seem to trim spaces?
		}
		return null;
	}
	return isset($_REQUEST[$s]) ? trim($_REQUEST[$s]) : "";
}

// expects var names separated by whitespace
function rts($s)
{
	rt(preg_split("/[ \t\n]+/", trim($s)));
}

function rti($s)
{
	$a = preg_split("/[ \t\n]+/", trim($s));
	rt($a);
	foreach($a as $v)
	{
		global $$v;
		$$v = (int)$$v;
	}
}


/* usage:
	hew("Hello world.") returns array("Hello", "world.")
	hew("Hello world.", "/[ .]+/") returns array("Hello", "world")
	hew("10;foo;;1.3", "/;/") returns array("10", "foo", "", "1.3")
	hew("10;foo;;1.3", "/;+/") returns array("10", "foo", "1.3")
	hew("
		Hello world.
		How's the weather?
		", "/[ .\?]+/") returns array( array("Hello", "world"), array("How's", "the", "weather") )
*/
function hew($s, $toksep = "/[ \t]+/", $linesep = null)
{
	$a = preg_split($toksep, trim($s));
	if($linesep == null)
		return $a;
	$l = count($a);
	for($i = 0; $i < $l; $i++)
	{
		$a[$i] = preg_split($linesep, trim($a[$i]));
	}
	return $a;
}



function greek($para)
{
	for($h = 0; $h < $para; $h++)
	{
		$sent = rand(2, 8);
		for($i = 0; $i < $sent; $i++)
		{
			$word = rand(4, 25);
			for($j = 0; $j < $word; $j++)
			{
				$let = rand(1,6);
				echo " ";
				for($k = 0; $k < $let; $k++)
					echo "x";
			}
			echo ".&nbsp;&nbsp;";
		}
		echo "</p>";
	}
}



function msgRedirect($msg, $a)
{
	header("Location: ".$_SERVER["SCRIPT_NAME"]."?action=msg&anchor=$a&msg=".urlencode($msg));
	exit;
}

function msgRedirectRed($msg, $a)
{
	msgRedirect("<font color=red>$msg</font>");
}



// not efficient, and not highly secure
function obfuscate_number($n)
{
	$s = "$n";
	$l = strlen($s);
	if(($l <= 0) || ($l > 9))
		fail("bad # of digits");

	$r = "$l";

	//srand(time(0));
	for($i = 0; $i < 20; $i++)
	{
		$x = rand() % 10;
		$r .= "$x";
		if($i == 9)
			$r .= "$n";
	}
	return "$r";
}

function unobfuscate_number($s)
{
	$l = intval($s{0});
	if(($l <= 0) || ($l > 9))
		fail("bad # of digits");

	$s = substr($s, 11, $l);
	$n = intval($s);
	return $n;
}



function selectStates($name = "state")
{
	$states = array(
		"Select a State", "",
		"ALABAMA", "AL", 
		"ALASKA", "AK", 
		"AMERICAN SAMOA", "AS", 
		"ARIZONA", "AZ", 
		"ARKANSAS", "AR", 
		"CALIFORNIA", "CA", 
		"COLORADO", "CO", 
		"CONNECTICUT", "CT", 
		"DELAWARE", "DE", 
		"DISTRICT OF COLUMBIA", "DC", 
		"FEDERATED STATES OF MICRONESIA", "FM", 
		"FLORIDA", "FL", 
		"GEORGIA", "GA", 
		"GUAM", "GU", 
		"HAWAII", "HI", 
		"IDAHO", "ID", 
		"ILLINOIS", "IL", 
		"INDIANA", "IN", 
		"IOWA", "IA", 
		"KANSAS", "KS", 
		"KENTUCKY", "KY", 
		"LOUISIANA", "LA", 
		"MAINE", "ME", 
		"MARSHALL ISLANDS", "MH", 
		"MARYLAND", "MD", 
		"MASSACHUSETTS", "MA", 
		"MICHIGAN", "MI", 
		"MINNESOTA", "MN", 
		"MISSISSIPPI", "MS", 
		"MISSOURI", "MO", 
		"MONTANA", "MT", 
		"NEBRASKA", "NE", 
		"NEVADA", "NV", 
		"NEW HAMPSHIRE", "NH", 
		"NEW JERSEY", "NJ", 
		"NEW MEXICO", "NM", 
		"NEW YORK", "NY", 
		"NORTH CAROLINA", "NC", 
		"NORTH DAKOTA", "ND", 
		"NORTHERN MARIANA ISLANDS", "MP", 
		"OHIO", "OH", 
		"OKLAHOMA", "OK", 
		"OREGON", "OR", 
		"PALAU", "PW", 
		"PENNSYLVANIA", "PA", 
		"PUERTO RICO", "PR", 
		"RHODE ISLAND", "RI", 
		"SOUTH CAROLINA", "SC", 
		"SOUTH DAKOTA", "SD", 
		"TENNESSEE", "TN", 
		"TEXAS", "TX", 
		"UTAH", "UT", 
		"VERMONT", "VT", 
		"VIRGIN ISLANDS", "VI", 
		"VIRGINIA", "VA", 
		"WASHINGTON", "WA", 
		"WEST VIRGINIA", "WV", 
		"WISCONSIN", "WI", 
		"WYOMING", "WY", 
		"Armed Forces Africa", "AE", 
		"Armed Forces Americas (except Canada)", "AA",
		"Armed Forces Canada", "AE", 
		"Armed Forces Europe", "AE", 
		"Armed Forces Middle East", "AE", 
		"Armed Forces Pacific", "AP",
		);
		
	$s = "<select name='$name' id='$name'>\n";
	for($i = 0; $i < count($states); $i += 2)
	{
		$l = $states[$i + 0];
		$a = $states[$i + 1];
		$s .= "<option value=\"$a\">$l</option>\n";
	}

	$s .= "</select>\n";
	return $s;
}



function simplemenu($a)
{
	echo "&bull; ";
	
	for($i = 0; $i < count($a); $i++)
	{
		$l = $a[$i];
		$u = strtolower($l).".php";

		echo "<a href='$u'>$l</a> &bull; ";
	}
}


function div($class, $guts)
{
	return "<div class='$class'>$guts</div>\n";
}

function txtbar($txt, $color)
{
	?>
	<div style="background-color: <?=$color?>; font-size: 16px; font-weight: bold; margin-top: 6px; margin-bottom: 6px; padding: 4px; text-align: center;">
	<?=$txt?>
	</div>
	<?
}

function headingbar($txt)
{
	txtbar($txt, "#bbddff");
}


function form1($title, $fnm)
{
	headingbar($title);
	print("<form method=POST name=\"$fnm\" id=\"$fnm\">\n");
}

function hidden($name, $value)
{
	print("<input type=hidden name=$name value=\"$value\">\n");
}

function submit($name, $value)
{
	print("<input type=submit name=$name value=\"$value\">\n");
}

function form2()
{
	print("</form>\n");
}

/*
function otherfld($fnm, $n, $v, $t, $p)
{
	if($t == "C")
	{
		// C: Char flds
		$sz = $p;
		if($sz > 80)
			$sz = 80;
		$v = enquote($v);
		print("<input type=text name=$n size=$sz maxlength=$p value=$v>\n");
	}
	else
	if($t == "X")
	{
		// X: Clob (char large obj)
		print("<textarea name=$n rows=4 cols=80>$v</textarea>\n");
	}
	else
	if($t == "I")
	{
		// I:  Integer field.
		if($p == 1)
		{
			$checked = ($v == 1) ? "checked" : "";
			print("<input type=checkbox value=1 name=$n $checked>");
		}
		else
		{
			print("<input type=text name=$n size=10 maxlength=10 value=\"$v\">\n");
		}
	}
	else
	if($t == "l")
	{
		// L: Logical field (boolean or bit-field)
		$checked = ($v == 1) ? "checked" : "";
		print("<input type=checkbox value=1 name=$n $checked>");
	}
	else
	if($t == "T")
	{
		// T: Timestamp field
		date_form($fnm, $v, $n);
		echo "(XXX this needs time editing)";
	}
	else
	if($t == "N")
	{
		// N: Numeric field (decimal, numeric, float, real)
		print("<input type=text name=$n size=16 maxlength=16 value=\"$v\">\n");
	}
	else
	if($t == "D")
	{
		// D: Date field (handle same as T?
		date_form($fnm, $v, $n);
	}
	else
	{
		// Unsupported:
		//		B: Blob, or binary large objects.
		//
		print("** UNSUPPORTED TYPE=$t **\n");
	}
}
*/

/*
function enquote($s)
{
	if(strstr($s, "'"))
	{
		// contains single quote
		if(strstr($s, '"'))
			p_fail("string contains both single and double quotes");
		return "\"".$s."\"";
	}
	if(strstr($s, '"'))
	{
		// contains double quote
		if(strstr($s, "'"))
			p_fail("string contains both single and double quotes");
	}
	return "'".$s."'";
}
*/


function send_mail($to, $from, $fromname, $subj, $body, $cc)
{
	global $apptitle;

	//$hdrs = "From: $apptitle <website@ambr.com>\n";
	$hdrs = "From: $fromname <$from>\n";
	if($cc != "")
		$hdrs .= "Bcc: <$cc>\n";
	$body = preg_replace("|\r|", "", $body);
	$body = preg_replace("|\n|", "\r\n", $body);
	return mail($to, $subj, $body, $hdrs);
}



function catch_and_send($e)
{
	global $dbg;
	?>
	<div style="border: solid 6px red; padding: 20pt; background-color: white; color: red;">
		<?
		$ick = $e->getMessage()."<p><pre>\n".$e->getTraceAsString()."\n</pre><br>";
		if($dbg)
		{
			echo $ick;
		}
		else
		{
			echo "<center>";
			echo "An internal error has occured.<br>";
			echo "The system administrator has been notified.<br>";
			echo "Sorry for the inconvenience.<br>";
			echo "<br>";
			echo "</center>";

			$from = "website@".$_SERVER["SERVER_NAME"].".com";
			$to = "jh@sleepless.com";
			$subj = "** EXCEPTION OCCURED **";
			$ick = preg_replace("/\n/", "\r\n", $ick);
			send_mail($to, $from, "Web Site", $subj, $ick, "");
		}
		?>
	</div>
	<?
}


function safepath($f)
{
	if(substr($f, 0, 1) == "/")			// first char '/' is bad
		return false;
	if(preg_match("/\.\./", $f))		// double dot anywhere is bad
		return false;
	return true;
}

function setcook($c, $v, $xm = 30)
{
	$r = setcookie($c, $v, time() + (60 * $xm), "/");
	$_COOKIE[$c] = $v;
}

function clrcook($c)
{
	$r = setcookie($c, FALSE, time() - 3600, "/");
	$_COOKIE[$c] = "";
}

function jmp($pg)
{
	global $dbg; 

	dbg("jmp to $pg");
	if($dbg)
	{
		echo "<br><a href='$pg'>jmp('$pg');</a></br>";
		exit;
	}
	header("Location: $pg");
	exit;
}

function jmpSSL()
{
	if($_SERVER["HTTPS"] != "on")
		jmp("https://".$_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"]);
}


/* returns a session id if authorization success.  otherwise "" */
function auth($u, $p, $xm = 30)
{
	$rs = dbExec("select * from auth_users where u_id=\"$u\" and pwd=\"$p\"");
	if($rs->RecordCount() > 0)
	{
		$pwd = $rs->fields("pwd");
		if($pwd == $p)
		{
			dbg("credentials valid");
			$sid = md5(uniqid(rand(), true));
			dbg("sid generated: $sid");
			dbExec("update auth_users set sid='$sid' where u_id='$u'");
			setcook("sid", $sid, $xm); 
			dbg("sid stored");
			logit($u, "LOGIN", "");
			return $sid;
		}
	}
	dbg("*** login failed ***");
	return "";
}

/* freshens cookie and returns true if sid is valid. if $jp is provided,
	then that page will be jumped to if verification fails */
function vrfy($sid, $jp = "", $xm = 30)
{
	$rs = dbExec("select * from auth_users where sid=\"$sid\"");
	if($rs->RecordCount() == 1)
	{
		dbg("sid freshened: $sid");
		setcook("sid", $sid, $xm); 		// freshen sid
		return true;
	}
	dbg("*** bad sid: $sid");
	if($jp != "")
		jmp($jp);
	return false;
}


function uid4sid($sid)
{
	return getfld("u_id", "auth_users", "where sid=\"$sid\"");
}

/* like preg_replace() except it doesn't use regexps.
	I need this because if there are an $ signs in th replacement
	str, they get interpreted by preg_replace ... */
function repl($p, $r, $s)
{
	$a = explode($p, $s);
	$n = $a[0];
	$l = count($a);
	for($i = 1; $i < $l; $i++)
	{
		$n .= $r;
		$n .= $a[$i];
	}
	return $n;
}


function validEmail($email)
{
	return preg_match("/^[A-Za-z0-9_\+-]+(\.[A-Za-z0-9_\+-]+)*@[A-Za-z0-9-]+(\.[A-Za-z0-9-]+)*\.([A-Za-z]{2,4})$/", $email);
}


$lamePasswords = array(
	"password",
	"12345678",
	"88888888",
	"abcdefgh",
	"liverpool",
	"baseball",
	"football",
	"letmein1",
	);
function commonPassword($p)
{
	$p2 = strtolower($p);
	global $lamePasswords;
	foreach($lamePasswords as $lp)
	{
		if($p2 == $lp)
			return true;
	}
	return false;
}
function weakPassword($password, $username = null, $fname = null, $lname = null)
{
	if(!is_string($password))
		return "Password is invalid";
	if(strlen($password) < 8)
		return "Password must be at least 8 characters long";
	if(commonPassword($password))
		return "Password is too common";
	if(is_string($username) && (strtolower($password) == strtolower($username)))
		return "Password is too easily guessed";
	if(is_string($fname) && (strtolower($password) == strtolower($fname)))
		return "Password is too easily guessed";
	if(is_string($lname) && (strtolower($password) == strtolower($lname)))
		return "Password is too easily guessed";
	return null;
}


function valsafe($s)
{
    return htmlentities($s, ENT_QUOTES);
}


function my2us_datetime($date)
{
	if($date == null)
		return "";
	if(substr($date,0,10) == "0000-00-00")
		return "";
	$a = preg_match_all("!([0-9]{1,4})-?([0-1]?[0-9])-?([0-3]?[0-9]) ?([0-2]?[0-9]):?([0-6]?[0-9]):?([0-6]?[0-9])!", $date, $aa);
	ass($a, "Invalid date/time value: \"$date\" (my2us_datetime())");
	ass(count($aa) == 7);
	return sprintf("%02d/%02d/%04d %02d:%02d", (int)$aa[2][0], (int)$aa[3][0], (int)$aa[1][0], (int)$aa[4][0], (int)$aa[5][0]);
}

function ts2my($ts)
{
	return date("Y-m-d H:i:s", $ts);
}

function now2my() {
	return ts2my(time());
}


function la($s)
{
	return preg_split("/\s*\n\s*/", trim($s));
}

function sleepyHash($s)
{
	return md5(sha1(str_rot13($s)));
}

function gensid($s = "")
{
	return "1".preg_replace("/[^0-9]+/", "", sha1($s.microtime(0)));
}

function X($s)
{
	throw new Exception($s);
}

function getSID()
{
	if ( 0==1 ) { // 'course it doesn't -- debug that finally gave boB the clue he needed
		$tmpStr = "_POST {";
		foreach ( $_POST as $k => $v ) { $tmpStr = "$tmpStr $k:$v, "; }
		dbg("$tmpStr }");
		$tmpStr = "_COOKIE {";
		foreach ( $_COOKIE as $k => $v ) { $tmpStr = "$tmpStr $k:$v, "; }
		dbg("$tmpStr }");
	}
	$origdomain = rt("origdomain");
	$sid = $origdomain ? $_POST["sid"] : rt("sid");
	if (!$sid) $sid = $_COOKIE["sid"];
	dbg("origdomain: '$origdomain'  sid: '$sid'");
	if(!$sid)
		return null;
	if(!preg_match("/[A-fa-f0-9]+/", $sid))
		return null;
	if(strlen($sid) != 32)
		return null;
	dbg("getSID() returning '$sid'");
	return $sid;
}

function my2us_date_y2($date)
{
    if($date == null)
        return "";
    if(substr($date,0,10) == "0000-00-00")
        return "";
    $a = preg_match_all("!([0-9]{1,4})-([0-1]?[0-9])-([0-3]?[0-9])!", $date, $aa);
	if(!$a)
		return null;
    if(count($aa) != 4)
		return null;
    return (int)$aa[2][0] . "/" . (int)$aa[3][0] . "/" . (substr($aa[1][0], 2, 2));
}

function h($s, $n) { return "<h$n>$s</h$n>"; }
function h1($s) { return h($s,1); }
function h2($s) { return h($s,2); }
function h3($s) { return h($s,3); }
function h4($s) { return h($s,4); }

function u($s) { return "<u>$s</u>"; }
function b($s) { return "<b>$s</b>"; }
function i($s) { return "<i>$s</i>"; }
function center($s) { return "<center>$s</center>"; }
function nowrap($s) { return "<span style='white-space: nowrap;'>$s</center>"; }

function a($url, $s) { return "<a href=\"$url\">$s</a>"; }
function ae($e,$n=0) { return stip("<a href=\"mailto:$e\">".ellipsize($e,$n)."</a>",$e); }
function am($e) { return ae($e); };

function stip($s, $t) { return "<span alt=\"$t\" title=\"$t\">$s</span>"; }

function ellipsize($s, $n)
{
	if($n >= 1)
	{
		if(strlen($s) > ($n - 3))
			return substr($s, 0, $n - 3)."...";
	}
	return $s;
}


function dirEntries($path, $inc = ".fdl")
{
	$noDotted = $inc[0] != ".";
	$noFiles = $inc[1] != "f";
	$noDirs = $inc[2] != "d";
	$noLinks = $inc[3] != "l";

	$entries = array();
	if($handle = opendir($path)) {
		while (false !== ($entry = readdir($handle))) {
			if($entry[0] == "." && $noDotted)
				continue;
			if(is_dir("$path/$entry") && $noDirs)
				continue;
			if(is_file("$path/$entry") && $noFiles)
				continue;
			if(is_link("$path/$entry") && $noLinks)
				continue;
			array_push($entries, $entry);
		}
		closedir($handle);
	}
	asort($entries);

	return $entries;
}


function ddd($s, $n = 15) {
	if(strlen($s) > $n)
		$s = substr($s, 0, $n - 4)." ...";
	return $s;
}
function squeeze($s, $n = 15) {
    if(strlen($s) > $n)
        $s = stip(ddd($s, $n), $s);
    return $s;
}


?>
