/* Copyright 2009 Sleepless Software Inc.  All Rights Reserved */
/*

	// italic //
	** bold **
	__ underline __
	$$ code $$

	+1 = <h1>
	+2 = <h2>
	etc.
	
	^^anchor-target^^

	::
		. unordered list item
		. unordered list item
	::

	##
		. ordered list item
		. ordered list item
	##

	-- = &ndash;
	--- = &mdash;
	---- = <hr>

	]] = <br>

	blank line ends paragraph

	(tm) = &trade;
	(r) = &reg;
	(c) = &copy;
*/

function qwiki(id)
{
	e = document.getElementById(id);
	t = e.innerHTML;
	t = t.replace(/\[last-modified\]/g, document.lastModified ? document.lastModified : "Unknown");
	t = t.replace(/\n\n+/g, "<p>\n");
	t = t.replace(/\+([1-9]) ([^\n]+)\n/g, "<h$1>$2</h$1><p>\n");
	t = t.replace(/\^\^([^\^]+)\^\^/g, "<a href=\"$1\">$1</a>\n");
	t = t.replace(/\n\s+\.\s*/g, "<li><p>");
	t = t.replace(/::(([^:]|:[^:])*)::/g, "<ul>$1</ul>");
	t = t.replace(/##([^#]*)##/g, "<ol>$1</ol>");
	t = t.replace(/__(([^_]|_[^_])*)__/g, "<u>$1</u>");		// underline
	t = t.replace(/\*\*(([^\*]|\*[^\*])*)\*\*/g, "<b>$1</b>");
	t = t.replace(/([^:])\/\/([^\/]*)\/\//g, "$1<i>$2</i>");
	t = t.replace(/{{/g, "<code><pre>");
	t = t.replace(/}}/g, "</pre></code>");
	t = t.replace(/\(tm\)/g, "&trade;");
	t = t.replace(/\(r\)/g, "&reg;");
	t = t.replace(/\(c\)/g, "&copy;");
	t = t.replace(/\]{2}/g, "<br>");
	e.innerHTML = t; return;
	t = t.replace(/([^-])-{4,}([^-])/g, "<hr>\n");
	t = t.replace(/``([^\n]+)\n/g, "<a name='$1'></a>\n");
	//t = t.replace(/\.[ \n]+([A-Za-z0-9])/g, ".&nbsp;&nbsp; $1");
	e.innerHTML = t;
}

