
var sys = require("sys")
var crypto = require("crypto")

// returns milliseconds since the Epoch
global.millis = function() { return new Date().getTime() }

// returns seconds since the Epoch
global.time = function() { return Math.floor(millis() / 1000) }

// convert object to JSON
global.o2j = function(o) { return JSON.stringify(o) }

// Convert json to object
global.j2o = function(j) { return JSON.parse(j) } 

// return human readable version of object
global.human = function(o) { return sys.inspect(o) }

global.sha1 = function(s) { var h = crypto.createHash("sha1"); h.update(s); return h.digest("hex") }


Array.prototype.iter = function(cb) {
	var i, l = this.length
	for(i = 0; i < l; i++) {
		if(cb(i, this[i]))
			break
	}
}




