
#error "This code is defunct.  You probably want SoundWave.cpp instead"

#if 0

#ifndef com_sleepless_bgwave_cpp
#define com_sleepless_bgwave_cpp

// Copyright 2002
// Sleepless Software Inc.
// All Rights Reserved


#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff 
#include <windows.h>
#include <mmsystem.h>

#include "io/File.cpp"


struct BGWave
{
	File *file;
	const unsigned char *mem;

	BGWave(const char *f)
	{
		file = 0;
		mem = 0;

		file = new File(f);
		if(file)
			mem = file->getBytes();
	}

	~BGWave()
	{
		if(file)
			delete file;
	}


	// Plays a raw .wav file image from memory.
	// Returns true if successful.
	void play()
	{
		PlaySound((const char *)mem, NULL, SND_NOSTOP | SND_MEMORY | SND_NODEFAULT | SND_ASYNC); 
	}

	void loop()
	{
		PlaySound((const char *)mem, NULL, SND_LOOP | SND_NOSTOP | SND_MEMORY | SND_NODEFAULT | SND_ASYNC); 
	}

	void stop()
	{
		PlaySound(0, NULL, SND_NOSTOP | SND_MEMORY | SND_NODEFAULT | SND_ASYNC); 
	}

};



#endif	// com_sleepless_bgwave_cpp
#endif
