
//package com.sleepless.crypt;


/*
   ************************************************************************* 
   WARNING: THIS CODE HAS A C++ COUNTERPART. DON'T CHANGE THIS WITHOUT ALSO
   MAKING THE CORRESPONDING CHANGES TO THE C++ VERSION.
   ************************************************************************* 

	This is hardly sophisticated.

	It stirs the bytes around but doesn't actually modify the individual
	bytes themselves.

	This is not even remotely sophisticated, and it is probably rather
	slow as well.

	NOTE!!!!!!
	There is a C/C++ version of this algorithm as well, which is used
	on the client side of a client/server app ... do NOT change this
	unless you know that you're not going to hose up this balancing act.
*/


class Obfuscate
{

	static final int [] oprimes = { 7, 13, 31, 11 };
	static final int [] rprimes = { 11, 31, 13, 7 };


	static void obfuscate(byte [] buf, int len)
	{
		for(int i = 0; i < 101; i++)
		{
			for(int j = 0; j < len; j++)
			{
				int ni = oprimes[ (j & 0x03) ] % len;
				byte tmp = buf[ ni ];
				buf[ ni ] = buf[ j ];
				buf[ j ] = tmp;
			}
		}
	}


	static void reveal(byte [] buf, int len)
	{
		for(int i = 0; i < 101; i++)
		{
			for(int j = len - 1; j >= 0; j--)
			{
				int ni = oprimes[ (j & 0x03) ] % len;
				byte tmp = buf[ j ];
				buf[ j ] = buf[ ni ];
				buf[ ni ] = tmp;
			}
		}
	}


	// Return obfuscated version of 's'
	static String obfuscate(String s)
	{
		byte [] ba = s.getBytes();
		obfuscate(ba, ba.length);
		return new String(ba);
	}

	
/*
	static void p(String s)
	{
		System.out.println(s);
	}
	


	public static void main(String [] args)
	{
		for(int i = 0; i < args.length; i++)
		{
			String s = args[i];
			int l = s.length();
			char [] cbuf = s.toCharArray();
			byte [] buf = new byte[l];
			for(int a = 0; a < l; a++)
			{
				int c = cbuf[a] & 0xff;
				buf[a] = (byte)c;
			}
			
			p( "in        : " + new String(buf));

			obfuscate(buf, buf.length);
			p( "obfuscated: " + new String(buf));

			reveal(buf, buf.length);
			p( "revealed  : " + new String(buf));
		}
	}
*/

		
}





