<?
// Copyright 2009 Sleepless Software Inc.  All Rights Reserved
class EONObject
{
};
class EON
{
	function o2e($obj)
	{
		if(is_object($obj))
		{
			$c = "";
			$s = "";
			foreach(get_object_vars($obj) as $k => $v)
			{
				//if(isset($v)) // xxx do i need this?
				{
					$s .= $c.$k.':'.$this->o2e($v);
				}
				$c = ",";
			}
//echo "{".urlencode($s)."}\n";
			return "{".urlencode($s)."}";
		}
		else
		if(is_array($obj))
		{
			$s = "";
			$l = count($obj);
			for($i = 0; $i < $l; $i++)
			{
				if($i != 0)
					$s .= ",";
				$s .= $this->o2e($obj[$i]);
			}
//echo "[".urlencode($s)."]\n";
			return "[".urlencode($s)."]";
		}
		else
		if(is_string($obj))
		{
			return '"'.urlencode($obj).'"';
		}
		else
		if(is_int($obj) or is_float($obj))
		{
			return $obj;
		}
		else
		if(is_bool($obj))
		{
			return $obj ? "true" : "false";
		}
		return "null";
	}
	
	function e2o($eon)
	{
		if(is_string($eon))
		{
			if(preg_match("/^\{[A-Za-z0-9%\/\.]*\}$/", $eon))
			{
				$o = new EONObject();
				if(preg_match("/^\{\}$/", $eon))
					return $o;
				$a = explode(",", urldecode(substr($eon, 1, strlen($eon) - 2)));
				$l = count($a);
				for($i = 0; $i < $l; $i++)
				{
					$a2 = explode(":", $a[$i]);
					if(count($a2) == 2)
					{
						if(preg_match("/^[A-Za-z0-9_]+$/", $a2[0]))
						{
							$o->$a2[0] = $this->e2o($a2[1]);
						}
					}
				}
				return $o;
			}
			else
			if(preg_match("/^\[[A-Za-z0-9%\/\.]*\]$/", $eon))
			{
				if(preg_match("/^\[\]$/", $eon))
					return array();
				$a = explode(",", urldecode(substr($eon, 1, strlen($eon) - 2)));
				$l = count($a);
				for($i = 0; $i < $l; $i++)
					$a[$i] = $this->e2o($a[$i]);
				return $a;
			}
			else
			if(preg_match("/^\"[A-Za-z0-9%\/\.]*\"$/", $eon))
			{
				return urldecode(substr($eon, 1, strlen($eon) - 2));
			}
			else
			if(preg_match("/^[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?$/", $eon))
			{
				return (float)$eon;
			}
			else
			if(preg_match("/^true$/", $eon))
			{
				return true; 
			}
			else
			if(preg_match("/^false$/", $eon))
			{
				return false; 
			}
			else
			if(preg_match("/^null$/", $eon))
			{
				return null; 
			}
		}
		return null;
	}
};
$EON = new EON();

$t = $_REQUEST["test"];
if($t)
{
	echo "<pre>";
	$o = new EONObject();
	$o->t = true;
	$o->f = false;
	$o->i = 3;
	$o->d = 5.7;
	$o->s = "foo";
	$o->a = array(1,2);
	$o->o = new EONObject();
	$o->o->n2 = 9;
	print_r($o);

	$e = $EON->o2e($o);
	echo "e=$e\n";

	$o = $EON->e2o($e);
	print_r($o);
}

	

?>
