<?

// required in common include at per-project level require_once("phpmailer/class.phpmailer.php");


class MyMailer extends PHPMailer {
//	global $guser; global $gpass;               // GMail user/pswd pair defined globally at per-project level (local.php)
	public $Mailer     = "smtp";                // Alternative to IsSMTP()
	public $SMTPAuth   = true;                  // enable SMTP authentication
	public $SMTPSecure = "ssl";                 // sets the prefix to the servier
	public $Host       = "smtp.gmail.com";      // sets GMAIL as the SMTP server
	public $Port       = 465;                   // set the SMTP port for the GMAIL server
//	public $Username   = $guser;                // GMAIL username
//	public $Password   = $gpass;                // GMAIL password


	// No-frills, exactly match old functionality call (less GMAIL auth pair parameters)
	function sendMail($to, $from, $fromname, $subj, $body, $cc = null, $bcc = null) {
		global $guser; global $gpass;               // GMail user/pswd pair defined globally at per-project level (local.php)
		$this->Username   = $guser;                // GMAIL username
		$this->Password   = $gpass;                // GMAIL password

		if($bcc) {
			foreach($bcc as $e) {
				$this->AddBCC($e);
			}
		}

		if ($cc) {
			foreach($cc as $e) { 
				$this->AddCC($e); 
			}
		}

		$todisp = "";
		if(!is_array($to))
			$to = array($to);
		foreach($to as $t) {
			$this->AddAddress($t, "");
			$todisp .= "$t ";
		}
		$this->SetFrom($from, $fromname);
		$this->Subject = $subj;
		$this->Body = $body;

		if(!$this->Send()) {
			fail("Could not send email to $todisp: " . $this->ErrorInfo);
			return false;
		}
		return true;
	}

}




// sendMail() is deprecated -- use MyMailer class methods above instead
function sendMail($to, $from, $fromname, $subj, $body, $cc, $guser, $gpass, $bcc = null)
{
	if(!is_array($to))
		$to = array($to);

	$mail = new PHPMailer();

	$mail->IsSMTP();
	$mail->SMTPAuth   = true;                  // enable SMTP authentication
	$mail->SMTPSecure = "ssl";                 // sets the prefix to the servier
	$mail->Host       = "smtp.gmail.com";      // sets GMAIL as the SMTP server
	$mail->Port       = 465;                   // set the SMTP port for the GMAIL server
	$mail->Username   = $guser; // GMAIL username
	$mail->Password   = $gpass; // GMAIL password
	if($bcc) {
		foreach($bcc as $e) {
			$mail->addBCC($e);
		}
	}

	$todisp = "";
	foreach($to as $t) {
		$mail->AddAddress($t, "");
		$todisp .= "$t ";
	}
	$mail->SetFrom($from, $fromname);
	$mail->Subject = $subj;
	$mail->Body = $body;

	if(!$mail->Send()) {
		fail("Could not send email to $todisp: ".$mail->ErrorInfo);
		return false;
	}

	return true;
}


?>
