<?
/*

	Copyright 2008 Sleepless Software Inc.
	All Rights Reserved

	You should do something like the following before including this file:

		$dbtype = "mysql";
		$dbhost = "ironguts.com";
		$dbuser = "test";
		$dbpasswd = "test";
		$dbname = "test";

		include "../db/db.php";

		$mb_table = "msgbrd";	// name of DB table for messages
		$mb_board = "poco";		// ID str for this msg board
								// This lets multiple msg brds use same DB

		// These define layout of the msg board on the page
		$mb_bg_color = "#f8eedd";
		$mb_head_bg_color = "#ddccbb";
		$mb_width = "640";
		$mb_border_color = "#884400";
		$mb_posted_msg = "Your message has been posted successfully.";
		$mb_msgs_per_page = 30;

		// when a posting is made, an email is generated using these vars
		$mb_email = "accept-guestbook@sleepless.com";
		$mb_email_from = "website@sleepless.com";
		$mb_email_subject = "Guest Book Entry";

	You can also include these $mb_fld_... vars to get prompts
	for additional fields.  The value of the var is the field name
	for that item.  For example, if you define $mb_fld_subject to
	be "subj" then the "Subject" field will be prompted for and
	an additional database field called "subj" should be in the table
	to receive it.  The currently supported additional fields are:

		$mb_fld_subject
	
	A table that looks like this should be in the database defined above:

		CREATE TABLE msgbrd (
		  id int(32) NOT NULL auto_increment,
		  created datetime NOT NULL default '0000-00-00 00:00:00',
		  body text NOT NULL,
		  subject varchar(128) NOT NULL default '',
		  author varchar(32) NOT NULL default '',
		  board varchar(16) NOT NULL default '',
		  PRIMARY KEY  (id)
		) TYPE=MyISAM;



*/


	$adminurl = "http://".$_SERVER["SERVER_NAME"].$_SERVER["SCRIPT_NAME"]."?admin=on&pw=foo";


	function rt($s)
	{
		return trim($_REQUEST[$s]);
	}

	$t = "x_".date("d"); //time() / (7 * 24 * 60 * 60);

	$s_action = $t."action";
	$s_author = $t."author";
	$s_subject = $t."subject";
	$s_body = $t."body";




	$admin = (rt("admin") == "on" && rt("pw") == "foo") ? true : false;



	// A cookie is used to remember the last "author" entered and the
	// last icon used.
	$mb_author = $_COOKIE["mb_author"];
	if($mb_author == null)
		$mb_author = "";
	$mb_icon = $_COOKIE["mb_icon"];
	if($mb_icon == null)
		$mb_icon = "";

	$style1 = "background-color: $mb_bg_color; width: $mb_width; border: solid 1px $mb_border_color";
	$style2 = "background-color: $mb_head_bg_color; border-bottom: solid 1px $mb_border_color; padding: 2px; margin-bottom: 8pt;";
	$style3 = "border-top: dotted 1px $mb_border_color; margin: 6pt;";


	$action = rt($s_action);

	$author = rt($s_author);
	if($author == "")
		$author = "Anonymous";

	$body = rt($s_body);

	$subject = rt($s_subject);

	$mb_lastid = $_GET["mb_lastid"];
	if($mb_lastid == "")
		$mb_lastid = 9999999999;

	if($mb_posted_msg == "")
		$mb_posted_msg = "Message posted successfully.";
	
	if($mb_msgs_per_page < 1)
		$mb_msgs_per_page = 20;


//print_vars();

	if($action == "mb_act_postmsg")
	{
		if($mb_nopost)
			exit;
		if($mb_forbid_pattern != "")
		{
			if(preg_match($mb_forbid_pattern, $body))
			{
				if(!preg_match($mb_forbid_except_pattern, $body))
					$body = "";
			}
		}

		if($body != "")
		{
			$fields = array("board", "created", "author", "body");
			$values = array("\"$mb_board\"", "now()", "\"$author\"", "\"$body\"");

			if($mb_fld_subject != "")
			{
				$fields[] = $mb_fld_subject;
				$values[] = "\"$subject\"";
			}

			if(insertRecord($mb_table, $fields, $values))
			{
				?>
					<div style="<?=$style1?>">
					<div style="<?=$style2?>"><b>Info</b></div>
					<?=$mb_posted_msg?>
					</div>
					<br>
				<?

				// If $mb_email is set, send copy of the msg to it
				$hdrs = "From: $mb_email_from\r\n";
				$body .= "\r\n\r\n$adminurl\r\n";
				mail($mb_email, $mb_email_subject, $body, $hdrs);

				// Remember 'author' using a cookie.
				if(ob_get_length())
				{
					setCookie("mb_author", $author, time()+((3600 * 24) * 30));
					setCookie("mb_icon", $icon, time()+((3600 * 24) * 30));
				}
			}
			else
			{
				?>
					<div style="<?=$style1?>">
					<div style="<?=$style2?>"><b>Info</b></div>
					** ERROR POSTING MESSAGE **
					</div>
					<br>
				<?
			}
		}
	}
	else
	if($action == "mb_nuke")
	{
		$id = rt("mb_id");
		deleteRecords($mb_table, "where id=$id");
	}


	if(!$mb_nopost)
	{
?>

<div style="<?=$style1?>">
<div style="<?=$style2?>"><b>Post a Message </b></div>
	<table style="padding-top: 10px">
<form method=post >
	<input type=hidden name=<?=$s_action?> value="mb_act_postmsg">
		<tr>
			<td> <b>Author:</b> </td>
			<td>
				<?
					if($mb_from != "")
					{
						?>
						<input type=hidden name=<?=$s_author?> value="<?=$mb_from?>">
						<?
						print("<b>".$mb_from."</b>");
					}
					else
					{
						?>
						<input type=text name=<?=$s_author?> maxlength=30 size=30 value="<?=$mb_author?>">
						<?
					}
				?>
			</td>
		</tr>

		<?
		if($mb_fld_subject != "")
		{
			?>
			<tr>
				<td> <b> Subject: </b> </td>
				<td>
					<?
						?>
						<input type=text name=<?=$s_subject?> maxlength=50 size=30>
						<?
					?>
				</td>
			</tr>
			<?
		}
		?>

		<tr>
			<td valign=top> <b>Message:</b> </td>
			<td> <textarea name=<?=$s_body?> rows=4 cols=55 valign=top></textarea> </td>

		</tr>

		<tr>
			<td colspan=2 align=right><input type=submit value="Post"></td>
		</tr>
</form>
	</table>

</div>

<?
	}
?>

<div style="<?=$style1?>">
<div style="<?=$style2?>"><b>Messages Posted by Others: </b></div>
<?

	$recs = getRecords($mb_table, "where board = \"$mb_board\" and id < $mb_lastid order by created desc limit $mb_msgs_per_page");

	$n = count($recs);
	for($i = 0; $i < $n; $i++)
	{
		$r = $recs[$i];
		$id = $r["id"];
		$author = $r["author"];
		$body = $r["body"];
		$created = $r["created"];
		$subject = $r["subject"];
		$mb_lastid = $id;

		?>
		<table width=100%>
			<tr>
				<td align=left> <b> Message #<?=$id?> </b></td>
				<td align=right>
					<?=$created?>
					<?
					if($admin)
					{
						?>
						<form>
							<input type=hidden name=<?=$s_action?> value=mb_nuke>
							<input type=hidden name=mb_id value=<?=$id?>>
							<input type=hidden name=admin value="on">
							<input type=hidden name=pw value="foo">
							<input type=submit value="Delete">
						</form>
						<?
					}
					?>
				</td>
			</tr>
			<tr>
				<td colspan=2> <b> Author: </b> <?=$author?> </td>
			</tr>
			<?
			if($mb_fld_subject != "")
			{
				?>
				<tr>
					<td colspan=2> <b>Subject:</b> <?=$subject?> </td>
				</tr>
				<?
			}
			?>
			<tr>
				<td colspan=2 style="padding-top: 6pt; padding-left: 18pt"> <?=$body?> </td>
			</tr>
		</table>
		<div style="<?=$style3?>"></div>
		<?
	}
?>

	<p>

	<?
		if($n >= $mb_msgs_per_page)
		{
			?>
			<center>
			<a href="?mb_lastid=<?=$mb_lastid?>"><b>Older Messages ...</b></a>
			</center>
			<p>
			<?
		}
	?>



</div>
