#ifndef com_sleepless_obfuscate_cpp
#define com_sleepless_obfuscate_cpp

// Copyright 2004 Sleepless Software Inc.  All Rights Reserved

/*
   ************************************************************************* 
   WARNING: THIS CODE HAS A JAVA COUNTERPART. DON'T CHANGE THIS WITHOUT ALSO
   MAKING THE CORRESPONDING CHANGES TO THE JAVA VERSION.
   ************************************************************************* 

	This is hardly sophisticated.

	It stirs the bytes around but doesn't actually modify the individual
	bytes themselves.

	This is not even remotely sophisticated, and it is probably rather
	slow as well.

*/



struct Obfuscate
{
	int oprimes[4];
	int rprimes[4];

	Obfuscate()
	{
		oprimes[0] = 7;
		oprimes[1] = 13;
		oprimes[2] = 31;
		oprimes[3] = 11;

		rprimes[0] = 11;
		rprimes[1] = 31;
		rprimes[2] = 13;
		rprimes[3] = 7;
	}

	void obfuscate(unsigned char *buf, int len)
	{
		for(int i = 0; i < 101; i++)
		{
			for(int j = 0; j < len; j++)
			{
				int ni = oprimes[ (j & 0x03) ] % len;
				unsigned char tmp = buf[ ni ];
				buf[ ni ] = buf[ j ];
				buf[ j ] = tmp;
			}
		}
	}


	void reveal(unsigned char *buf, int len)
	{
		for(int i = 0; i < 101; i++)
		{
			for(int j = len - 1; j >= 0; j--)
			{
				int ni = oprimes[ (j & 0x03) ] % len;
				unsigned char tmp = buf[ j ];
				buf[ j ] = buf[ ni ];
				buf[ ni ] = tmp;
			}
		}
	}

		
};


#endif	// com_sleepless_obfuscate_cpp
