#ifndef com_sleepless_sys_semaphore_cpp
#define com_sleepless_sys_semaphore_cpp


// XXX
// XXX
// BROKEN BROKEN BROKEN BROKEN
// BROKEN BROKEN BROKEN BROKEN
// BROKEN BROKEN BROKEN BROKEN
// BROKEN BROKEN BROKEN BROKEN
// BROKEN BROKEN BROKEN BROKEN
// BROKEN BROKEN BROKEN BROKEN
// XXX
// XXX

/* Copyright 2004 Sleepless Software Inc.  All Rights Reserved */


#ifdef WIN32
#include <windows.h>
#endif

#if defined(linux) || (defined(__APPLE__) && defined(__GNUC__))
#include <semaphore.h>
#include <errno.h>
#endif


struct Semaphore
{

#ifdef WIN32
#endif


#if defined(linux) || (defined(__APPLE__) && defined(__GNUC__))

	sem_t *sem;
	char sem_name[100];


	Semaphore(const char *name = 0)
	{
		if(name)
			STR_CPY(sem_name, name);
		else
			sprintf(sem_name, "sem.%d", time(0));
		sem = sem_open(name, O_CREAT, 0777, 1);
	}

	~Semaphore()
	{
		if(sem != SEM_FAILED)
			sem_unlink(sem_name);
	}

	void lock()
	{
		if(sem != SEM_FAILED)
			sem_wait(sem);
	}

	void unlock()
	{
		if(sem != SEM_FAILED)
			sem_post(sem);
	}

	// Returns 1 if lock acquired, 0 otherwise.
	int tryLock()
	{
		if(sem != SEM_FAILED)
			return (sem_trywait(sem) == 0) ? 1 : 0;
		return 1;
	}

#endif



};


#endif	// com_sleepless_sys_semaphore_cpp

