<?
require "sleepylib/dbg.php";
$sid = $_COOKIE["sid"];
$rip = $_SERVER["REMOTE_ADDR"];
$agent = $_SERVER["HTTP_USER_AGENT"];
dbg("sid=$sid");
dbg("rip=$rip");
dbg("agent=$agent");
if($sid != sha1($rip.$agent)) {
	dbg("denied");
	exit;
}
dbg("ok");
?>
<html>
<head>
	<style>
		.box {
			border: solid 1px #aaa;
			-moz-border-radius:5px;
			-webkit-border-radius:5px;
			padding: 0.25em;
			margin: 0.1em 0 0.1em 0;
			text-align: center;
			font-weight: bold;
			font-family: helvetica;
		}
		#spinner {
			display: none;
			text-align: center;
		}
		form {
			margin: 0;
		}
	</style>
	<script>
		function el(id) { return document.getElementById(id); }
	</script>
	<?
	function rv($s) { return trim($_REQUEST[$s]); }
	//function dbg($s) { echo "$s<br>\n"; }
	function fail($s) { ?><div id=failbox class=box> <?=$s?> </div><? exit; }
	?>
</head>
<body>
<!-- pre><? print_r($_REQUEST); ?></pre>
<pre><? print_r($_FILES); ?></pre -->
<?

$pre = rv("pre");
if(preg_match("/(^\/|\.\.+|[^-_.\/A-Za-z0-9]+)/", $pre))
	fail("Invalid storage area.");


$nukefile = rv("nukefile");
if($nukefile)
{
	@unlink($pre."/".$nukefile);
}


$u = $_FILES["fup"];
$file = $u['name'];
if($file)
{
	if(!file_exists($pre))
		@mkdir($pre, 0775, true);

	// sanitize filename
	$file = str_replace("$", "", $file);		
	$file = preg_replace("/\.\.+/", ".", $file);
	$file = preg_replace("/[^-_.A-Za-z0-9]+/", "", $file);

	$path = $pre."/".$file;
	if(!move_uploaded_file($u['tmp_name'], $path))
		fail("Can't move \"".$u['tmp_name']."\" to \"".$path."\".");
		//fail("Can't move file to storage area.");

	if(!chmod($path, 0664))
		fail("Can't update file permissions.");
}


if($dh = opendir($pre))
{
	$a = array();
    while(($file = readdir($dh)) !== false)
	{
		if($file[0] != ".")
			array_push($a, $file);
    }
    closedir($dh);

	asort($a);

	foreach($a as $n=>$file)
	{
		$path = $pre."/".$file;
		?>
		<div class=box>
			<form id='n<?=$n?>' method='post'>
				<input type=hidden name=nukefile value='<?=$file?>'>
				<a target=ext href='<?=$path?>'><?=$file?></a>
				<input type=submit value='Delete'>
			</form>
		</div>
		<?
		}
}

?>

<script>
	function sendIt()
	{
		el('spinner').style.display = 'block';
		el('uploadform').submit();
		el('fileinput').style.display = 'none';
	}
</script>
<div id=uploadbox class=box>
	<div id=spinner> <img src='images/spinner.gif'> </div>
	<form id='uploadform' method="post" enctype="multipart/form-data">
		<div id=fileinput>
		Upload file: <input name="fup" type="file" onchange='sendIt()'>
		</div>
	</form>
</div>

</body>
</html>
